#Remote imports
import pygame

#Local imports
from pgu import gui, high

#----------------------------------------------
#CONSTANTS
#----------------------------------------------

#Screen
FRAME_RATE = 30
OFFSCREEN = (-500, -500)

#Rooms
TITLE_SCREEN = 1
GAME_MODE_ROOM = 3
GAME_ROOM = 2
HIGH_SCORES_ROOM = 4

#Game modes
RELAXED = 1
TIME_CHALLENGE = 2
PLAN_AHEAD = 3

#Difficulties
EASY = 1
MED_DIF = 2
HARD = 3
SUPER = 4

#Board
BOARD_SMALL = (4, 4)
BOARD_MED = (6, 4)
BOARD_LARGE = (6, 6)

#Continents
EUROPE = 1
AFRICA = 2

#Trip
TRIP_SMALL_TO_DEAL = 10
TRIP_MED_TO_DEAL = 17
TRIP_LARGE_TO_DEAL = 23

TRIP_SMALL_TO_WIN = 7
TRIP_MED_TO_WIN = 14
TRIP_LARGE_TO_WIN = 21

#Cards
CARD_SMALL = (70, 70)
CARD_MED = (85, 85)
CARD_LARGE = (100, 100)

CARD_SPEED_SLOW = .3
CARD_SPEED_MED = .5
CARD_SPEED_FAST = .7

#Colors
GRAY1 = (72, 72, 72)
GRAY2 = (92, 92, 92)
GRAY3 = (126, 126, 126)
GRAY4 = (155, 155, 155)
GRAY5 = (182, 182, 182)
GRAYS = [GRAY1, GRAY2, GRAY3, GRAY4, GRAY5]

COLOR1 = pygame.Color('#b42a0b')      #Red
COLOR2 = pygame.Color('#ecb911')      #Yellow  
COLOR3 = pygame.Color('#346b10')       #Green
COLOR4 = pygame.Color('#7aa59b')      #Light Blue
COLOR5 = pygame.Color('#40565c')        #Dark Blue

#----------------------------------------------
#Variables
#----------------------------------------------

#Screen
screen_size = (1024, 600)
screen_center = (screen_size[0]/2, screen_size[1]/2)
gui_theme = gui.Theme("assets/images/gui/themes/default")

#Rooms
room = GAME_MODE_ROOM
all_highs = high.Highs('high_scores.txt')
current_highs = high.Highs('high_scores.txt')['time_challenge_med']

#Game
board_size = BOARD_LARGE
map_size = (520, 520)
fill_board = 1
use_darkness = 1

#Game Modes
game_mode = TIME_CHALLENGE
time_challenge_start_time = 40
min_advance_time = 20
max_time_bank = 200

#Difficulty
difficulty = MED_DIF

#Continent
continent = AFRICA

#Trip
longest_trip_needed = TRIP_LARGE_TO_WIN              #How many cards in a trip
longest_trip_to_deal = TRIP_LARGE_TO_DEAL

#Cards
card_size = CARD_SMALL
card_speed = .3

#Options
card_font_size = 10
interface_font_size = 14

#Fonts
font_mono = 'assets/fonts/LiberationMono-Bold.ttf'
font_sans = 'assets/fonts/LiberationSans-Bold.ttf'

#Misc
default_zoom_time = 400 #Default zoom time for ZoomImage in my_gui.py, in ms
zoom_lifetime = 1000 #How long in ms will the zoom images stay around before zooming back out?
default_fade_time = 2500 #Default fade time for FadeOut in my_gui.py, in ms


#card_speed = ((card_size[0]**2 + card_size[1]**2) / 100) * .004   #pixels to travel per millisecond